#include <f77/f77_floatingpoint.h>

	program call

	real array(0:3), rroot(3), iroot(3), in
	real err, val
	integer count, fl(3), i
	logical over, under, prob

	ieeer=ieee_flags('clear', 'exception', 'all', out)

10	format (i3, i3, e15.7, e15.7, e15.7)
11	format (i3)
12	format (4e11.3)
13	format (i3, i3, e15.7, e15.7, e15.7, e15.7)

	open(1, file='cubic.results')
	open(2, file='cubic.data')

	array(3)=1.
c	do 40 count=-38, 37, 1
c	count=7
	   in=10.**count
	   array(2) = 6. - in
	   array(1) = 10. - 6.*in
	   array(0) = -10.*in


15	read (2, 12, end=40) array(3), array(2), array(1), array(0)

	  call cubic(array, rroot, iroot, fl)

	  write (1, *)
	  do 20 i=1, 3, 1
	   if (fl(i) .ne. -6) then
	      call Values(array, rroot(i), iroot(i), err, val)
c	      write (1, 10) count, fl(3), abs(rroot(3)-in), val, err
	      write (1, 13) count+1, fl(i), rroot(i), iroot(i), val, err
	   else
	      write (1, 11) count
	   endif
20	  continue

	go to 15

40	continue


	call exceptions(over, under, prob)

	stop
	end




	subroutine Values(arr, r, i, err, val)
	real arr(0:3), r, i, err, val

	real ej, ek, delta, bj, bk, Mag
	integer count
	logical over, under, prob
	complex x, cbj, cbk

	delta=2.**(-24)

	if (i .eq. 0.) then

           bj = arr(3)
           ej = abs(bj)*delta
           do 150 count=2, 0, -1
	      print *, bj, arr(count)
              bk = r*bj + arr(count)
	      ek = abs(r)*ej 
	      ek=ek+(abs(r*bj)*delta+abs(arr(count)))*(2+delta)*delta
              bj=bk
              ej=ek
150        continue
	   print *, bj

           val=abs(bk)
	   err=ej

	else
	   x=cmplx(r, i)
           cbj = cmplx(arr(3), 0.)
           ej = Mag(cbj)*delta
           do 160 count=2, 0, -1
              cbk = x*cbj + cmplx(arr(count), 0.)
              ek = Mag(x)*ej 
	      ek=ek+(Mag(x*bj)*delta+Mag(arr(count)))*(2+delta)*delta
              cbj=cbk
              ej=ek
160        continue

           val=Mag(cbk)
	   err=ej
	endif

	call exceptions(over, under, prob)

	return
	end
